Attribute VB_Name = "Funktionen"
Option Explicit

Global Received As String           'Empfangspuffer
Global ETX, ACK, NAK As String      'zum besseren Lesbarkeit.
Global Timeout As Integer           'Antwortzeit begrenzen

Function Checksum(Telegramm As String)

    'Berechnet die Prfsumme aus einem Telegramm
    
    Dim i As Integer
    Dim ChecksumInt As Integer
    Dim ChecksumHex As String


    'Berechnung der Prfsumme (siehe FE3 Bus-Beschreibung)
        ChecksumInt = 0
    For i = 1 To Len(Telegramm)
        ChecksumInt = ChecksumInt + Asc(Mid$(Telegramm, i, 1))
    Next i

    'Wandeln in HEX
    ChecksumHex = Hex$(ChecksumInt)

    If Len(ChecksumHex) = 1 Then
        'Wenn nur 1 Zeichen Lnge, dann um fhrende "0" ergnzen
        ChecksumHex = "0" & ChecksumHex
    Else
        'Ansonsten zhlen nur die letzten beiden Zeichen der Prsumme
        ChecksumHex = Mid$(ChecksumHex, Len(ChecksumHex) - 1, 2)
    End If

    'Prfsumme zurckgeben
    Checksum = ChecksumHex

End Function
